#include <avr/io.h>
#include "uart0.h"

char uart0_buf[80];

void uart0_init(void) {
	/* Set baud rate */
	unsigned int ubrr = MYUBRR;
	UBRR0H = (unsigned char)(ubrr>>8);
	UBRR0L = (unsigned char)ubrr;

	/* Enable receiver and transmitter */
	UCSR0B = (1<<RXEN0)|(1<<TXEN0);
	//UCSR0B = _BV(RXEN0) | _BV(RXCIE0);

	/* Set frame format: 8data, 2stop bit */
	UCSR0C = (1<<USBS0)|(3<<UCSZ00);   
}

void uart0_putc(unsigned char data) {
	while (!( UCSR0A & (1<<UDRE0)));							// Wait TXD Buffer Empty  
	UDR0 = data;												// Write Data  
}

unsigned char uart0_getc() {
	while(!(UCSR0A & (1<<RXC0)));								// Wait RXD Receive Data Ready
	return (UDR0);												// Get Receice Data & Return
}

void uart0_putstr(unsigned int *buffer) {
	char * ptr = (char *)buffer;
	int c;

	while (*ptr != '\0') { 				// End of String
		c = *ptr++;

		if (c == '\n') {  				// Enter
			uart0_putc(0x0D);  			// Enter
	  	} else if (c == '\r') {			// Line Feed
		  	uart0_putc(0x0A); 			// Line Feed
		} else {	
	  		uart0_putc(c); 				// Character      
		}	
	}
}

